/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

/** @module vertx-auth-oauth2-js/micro_profile_rbac */
var utils = require('vertx-js/util/utils');
var OAuth2RBAC = require('vertx-auth-oauth2-js/o_auth2_rbac');

var io = Packages.io;
var JsonObject = io.vertx.core.json.JsonObject;
var JMicroProfileRBAC = Java.type('io.vertx.ext.auth.oauth2.rbac.MicroProfileRBAC');

/**
 Implementation of the Microprofile MP-JWT 1.1 RBAC based on the access token groups key.

 @class
*/
var MicroProfileRBAC = function(j_val) {

  var j_microProfileRBAC = j_val;
  var that = this;

  var __super_create = this.create;
  // A reference to the underlying Java delegate
  // NOTE! This is an internal API and must not be used in user code.
  // If you rely on this property your code is likely to break if we change it / remove it without warning.
  this._jdel = j_microProfileRBAC;
};

MicroProfileRBAC._jclass = utils.getJavaClass("io.vertx.ext.auth.oauth2.rbac.MicroProfileRBAC");
MicroProfileRBAC._jtype = {accept: function(obj) {
    return MicroProfileRBAC._jclass.isInstance(obj._jdel);
  },wrap: function(jdel) {
    var obj = Object.create(MicroProfileRBAC.prototype, {});
    MicroProfileRBAC.apply(obj, arguments);
    return obj;
  },
  unwrap: function(obj) {
    return obj._jdel;
  }
};
MicroProfileRBAC._create = function(jdel) {var obj = Object.create(MicroProfileRBAC.prototype, {});
  MicroProfileRBAC.apply(obj, arguments);
  return obj;
}
/**
 Factory method to create a RBAC handler for tokens adhering to the MP-JWT 1.1 spec.

 @memberof module:vertx-auth-oauth2-js/micro_profile_rbac

 @return {OAuth2RBAC} a RBAC validator
 */
MicroProfileRBAC.create =  function() {
  var __args = arguments;
  if (__args.length === 0) {
    return utils.convReturnVertxGen(OAuth2RBAC, JMicroProfileRBAC["create()"]()) ;
  }else throw new TypeError('function invoked with invalid arguments');
};

module.exports = MicroProfileRBAC;